/*
 * $Id: fp_get_atts.c,v 1.2 1997/01/07 16:44:10 veran Exp $
 */

/*
### assign color and symbol type to a given periodic orbit or equilibria ###
*/

#include <stdio.h>

#include <constants.h>
#include <defaults.h>
#include <fixed.h>

void
fp_get_attributes(fp)
     struct Fixpt_DataS *fp;
{
  switch (fp->fptype)
    {
    case SADDLE:
      sprintf(fp->name,"SADDLE");
      fp->prop_cntl.sys_color = SADDLE_COLOR;
      fp->prop_cntl.symbol = SADDLE_SYMBOL;
      break;
    case SOURCE:
      sprintf(fp->name,"SOURCE");
      fp->prop_cntl.sys_color = SOURCE_COLOR;
      fp->prop_cntl.symbol = SOURCE_SYMBOL;
      break;
    case SINK:
      sprintf(fp->name,"SINK");
      fp->prop_cntl.sys_color = SINK_COLOR;
      fp->prop_cntl.symbol = SINK_SYMBOL;
      break;
    case SPIRAL_SOURCE:
      sprintf(fp->name,"SPIRAL SOURCE");
      fp->prop_cntl.sys_color = SOURCE_COLOR;
      fp->prop_cntl.symbol = SOURCE_SYMBOL;
      break;
    case SPIRAL_SINK:
      sprintf(fp->name,"SPIRAL SINK");
      fp->prop_cntl.sys_color = SINK_COLOR;
      fp->prop_cntl.symbol = SINK_SYMBOL;
      break;
    case INDETERMINATE:
    default:
      sprintf(fp->name,"INDETERMINATE");
      fp->prop_cntl.sys_color = DEFAULT_FP_COLOR;
      fp->prop_cntl.symbol = DEFAULT_FP_SYMBOL;
      break;
    }
}
