/*
 * $Id: manifold.h,v 1.2 1997/05/09 22:09:10 worfolk Exp $
 */

#ifndef MANIFOLD_h
#define MANIFOLD_h

/*
 * manifold.h
 *
 * defines the data structure for (currently simple) manifolds
 *
 */

typedef struct manifold_struct {
  		int 		type;		  /* EUCLIDEAN, PERIODIC */
		int		*periodic_varb;	  /* which variables are periodic?... */
		double 		*period_start;	  /* ...and what values shall we use to begin... */
		double		*period_end;	  /* ...and end the period, eg period = end - start */
		}  Manifold;

#define	EUCLIDEAN	50
#define	PERIODIC	51

double lift(int v_dim, double *x, double *y,
     double *closest_pt, Manifold *manifold );
int project( int v_dim, double *p, Manifold *manifold);
int project_and_flag( int v_dim, double *p, Manifold *manifold);


#endif /* MANIFOLD_h */

