/*
 * $Id: modellib.h,v 1.1 1997/01/07 16:47:14 veran Exp $
 */

#ifndef MODELLIB_HEADER
#define MODELLIB_HEADER

/* include file for accessing a dynamical system model */
/* dynamical system data structure definition */

struct	DS_DataS	{
		int	Category;
  		char	*DS_Name;	  /* name of dynamical system */
		int	(*ds_init)();	  /* initialization routine which sets postmaster variables */
	      };

extern	struct	DS_DataS DS_Sel[], USER_DS_Sel[], DS_model;

extern  char	*DS_Category[], *USER_DS_Category[];
extern  int	N_DS, N_USER_DS, N_DS_Category, N_USER_DS_Category;


/* declarations for models.c */
void get_ds_func(double *func, double *varb, double *param);
void get_gv_func(double *func, double *varb, double *param);
int valid_func(void);
char *get_ds_name(void);
void varb_setup(int n_varb, char **variable_names,
		double *variables, double *variable_min, double *variable_max,
		char *indep_varb_name,
		double indep_varb_min, double indep_varb_max);
void param_func_setup(int n_param, int n_funct,
		 char **parameter_names, char **funct_names,
		 double *parameters,
		 double *parameter_min, double *parameter_max,
		 double *funct_min, double *funct_max);
void phase_sp_setup(int n_varb, int manifold_type,
		    int *periodic_varb, 
		    double *period_start, double *period_end );
void geomview_setup(int gv_n, char *gv_filename);


#endif


