/*
 * $Id: sys_install.c,v 1.4 1997/05/07 15:47:04 veran Exp $
 */

/*
 * sys_install.c
 *
 * Procedures:
 *   sys_install()
 *
 * Here we install the postmaster objects
 * which will always exist.
 *
 */
#include <stdio.h>

#include "pm.h"
#include "init_local.h"

static PFV sys_install_procs[] = {
  model_install,
  selected_install,
  manifold_install,
  memory_install,
  flow_install,
  prop_install,
  color_install,
  mult_install,
  browser_install,
  fixed_install,
  man2d_install,
  porbit_install,
  defaults_install,
  geomview_install,
  parser_install,
  save_install,
  load_install,
  view_install,
  print_install, 
  cont_install,
  twod_install
/*
  oned_install,
*/
  };

#define N_SYS_INSTALL sizeof(sys_install_procs)/sizeof(PFV)

void
  sys_install()
{
  int i;

  for (i=0; i<N_SYS_INSTALL; i++)
    if (sys_install_procs[i] != (PFV) NULL)
      sys_install_procs[i]();

}

extern int N_USER_INSTALL;
extern PFV user_install_procs[];

void
user_install()
{
  int i;

  for (i=0; i<N_USER_INSTALL; i++)
    if (user_install_procs[i] != (PFV) NULL)
      user_install_procs[i]();

}

