/*
 * $Id: jacobian.c,v 1.3 1997/05/08 18:45:14 veran Exp $
 */

/*
 * jacobian.c
 *
 */
#include <pm.h>
#include <stdlib.h>

#include "math_utils.h"

/*
 * compute jacobian for flows only!!!!!
 *
 */

static int (*vf)(double *f, double *x, double *p);
static int (*jac_fn)(double** jac, double *x, double *p);


void
compute_jacobian(double **jac, double *x, double *p, double *dx,
		 int n, double *work)
{
  int i,j;
  vf = (int (*)()) pm(GET, "Model.DS_Def", NULL);
  jac_fn = (int (*)()) pm(GET, "Model.DfDx", NULL);

  if (jac_fn) /* jacobian function given! */
    {
      jac_fn(jac, x, p);
    }
  else /* do central differencing */
    {
      double *x1 = work;
      double *u = work+n+1;
      double *v = u+n;
      vf(u, x, p);
      dcopy(n+1,x1,1,u,1);
      for(j=0; j<n; j++)
	{
	  x1[j] += dx[j];
	  vf(u, x1, p);
	  x1[j] -= 2.0*dx[j];
	  vf(v, x1, p);
	  for(i=0; i<n; i++)
	    jac[i][j] = (0.5/dx[j])*(u[i]-v[i]);
	  x1[j] = x[j];
	}
    }
  return;
}
