/*
 * $Id: man2d_clear.c,v 1.3 1997/05/08 18:45:14 veran Exp $
 */

/*
 * man2d_clear.c
 *
 */

#include <stdlib.h>

#include "memory.h"
#include "pm.h"
#include "constants.h"
#include "utilities.h"
#include "math_utils.h"

void
man2d_clear(void)
{
  memory m;
  int man2d_test();
  
  system_mess_proc(0,"In man2d_clear\n");

  m = (memory) pm(GET, "Memory.Fixed", NULL);
  memory_clear_selected_flows(m,man2d_test);
  pm(EXEC, "Memory.Count", NULL);
}


/* 
 * man2d_test(p,n)
 *           p ptr to the integer parameters
 *           n number of integer parameters
 *
 * procedure to test whether a flow is a 2d manifold
 *
 * last modified: 1/8/96  paw
 */
int
man2d_test(int* p, int n)
{
  if (n != 1) return(FALSE);
  if (abs(p[0]) != abs(STAB_MAN2D)) return(FALSE);
  return(TRUE);
}
