/*
 * $Id: man2d_install.c,v 1.2 1997/01/07 16:51:12 veran Exp $
 */

/*
 * man2d_install.c
 *
 * Procedures:
 *   man2d_install()
 *   man2d_reset()
 */
#include <stdio.h>
#include <constants.h>
#include <defaults.h>
#include <pm.h>

static char *MAN2D_OBJ_NAME = "Man2d";

static char *MAN2D[] = {
  "Man2d.Algorithm",
  "Man2d.Eigen_Dist",
  "Man2d.Stepsize",
  "Man2d.Steps",
  "Man2d.Points",
  "Man2d.Dist",
  "Man2d.Skip",
  "Man2d.Go",
  "Man2d.Clear",
  "Man2d.Reset"
};

typedef enum {
  ALGORITHM=0, EIGEN_DISTANCE, M_STEPSIZE, STEPS, POINTS, DIST, SKIP, GO, CLEAR_MAN, RESET
} MAN2D_t;


void
  man2d_install()
{
  void man2d_go(), man2d_clear(), man2d_reset();

  pm(CREATE_OBJ, MAN2D_OBJ_NAME,
     CREATE_ELEM, MAN2D[ALGORITHM], INT,
     CREATE_ELEM, MAN2D[EIGEN_DISTANCE], DBL,
     CREATE_ELEM, MAN2D[M_STEPSIZE], DBL,
     CREATE_ELEM, MAN2D[STEPS], INT,
     CREATE_ELEM, MAN2D[POINTS], INT,
     CREATE_ELEM, MAN2D[DIST], DBL,
     CREATE_ELEM, MAN2D[SKIP], INT,
     CREATE_ELEM, MAN2D[GO], FNCT,
     CREATE_ELEM, MAN2D[CLEAR_MAN], FNCT,
     CREATE_ELEM, MAN2D[RESET], FNCT,
     NULL);

  pm(INIT, MAN2D[GO],
     INIT, MAN2D[CLEAR_MAN],
     INIT, MAN2D[RESET],
     PUT, MAN2D[GO], man2d_go,
     PUT, MAN2D[CLEAR_MAN], man2d_clear,
     PUT, MAN2D[RESET], man2d_reset,
     NULL);

}

void
  man2d_reset()
{
  pm(PUT, MAN2D[EIGEN_DISTANCE], MAN2_EIGEN_DIST,
     PUT, MAN2D[M_STEPSIZE], MAN2_STEPSIZE,
     PUT, MAN2D[STEPS], MAN2_STEPS,
     PUT, MAN2D[POINTS], MAN2_POINTS,
     PUT, MAN2D[DIST], MAN2_DIST,
     PUT, MAN2D[SKIP], MAN2_SKIP,
     NULL);
}
