/*
 * $Id: man2d_local.h,v 1.2 1997/05/08 18:45:14 veran Exp $
 */

/*
 * man2d.h
 */

#ifndef MAN2D_LOCAL_h
#define MAN2D_LOCAL_h

#include "memory.h"
#include "ring_local.h"

struct Man2d_DataS {
  int algorithm;
  double eigen_dist;
  double stepsize;
  int points;
  int steps;
  memory memory;
  int v_dim;
  int p_dim;
  int (*vf)();
  double fd_step;
  double *p;
  double *x1;
  double *x2;
  double *x3;
  double *f;
  double *work;
  double **jacobian, **jact;
  double **eval, **evectors;
  int *indx;
  int ev1, ev2, stability;
  int color;
  int symbol;
  int man_type;
  double dist;
  int skip;
};

ring linear_approx(struct Man2d_DataS *s);
int normal_set_vf(int (*vf_func)(), int dim);
int normal_vf(double *f, double *x, double *p);
int rk4(double *vx1, double *vx, double *param, double time_step,
    int dim, int (*f_p)(), double *workspace);

void man2d_go(void);
int man2d_load(struct Man2d_DataS *s);
int release_man2d(struct Man2d_DataS *s);
void compute_jacobian(double **jac, double *x, double *p, double *dx,
		      int n, double *work);


int simple(struct Man2d_DataS *s);
int flow_man(struct Man2d_DataS *s);
void simple_interp(ring r, double dist);
double avg_dist(ring r);


#endif /* !MAN2D_LOCAL_h */
