/*
 * $Id: normal_vf.c,v 1.3 1997/05/08 18:45:14 veran Exp $
 */

/*
 * normal_vf.c
 *
 * normal_vf
 */
#include <math.h>

static int (*vf)(double *f, double *x, double *p);
static int vf_dim;

int
normal_set_vf(int (*vf_func)(), int dim)
{
  vf = vf_func;
  vf_dim = dim;
  return 0;
}

/*
 * normal_vf
 *
 * evaluates a vector field and returns a unit length vector
 * or 0 vector if vf is 0 at the point
 */
int
normal_vf(double *f, double *x, double *p)
{
  double norm = 0.0;
  int status, i;
  
  status = vf(f,x,p);
  for (i=0; i<vf_dim; i++)
    {
      norm += f[i]*f[i];
    }
  norm = sqrt(norm);

  if (norm > 0.0)
    for (i=0; i<vf_dim; i++)
      f[i] /= norm;

  return status;
}
