/*
 * $Id: ring_local.h,v 1.2 1997/05/08 18:45:14 veran Exp $
 */

/*
 * ring_local.h
 *
 */

#ifndef RING_LOCAL_h
#define RING_LOCAL_h

#include "memory.h"

typedef struct ring_item {
  int index;
  double *x;
  int x_dim, size;
  struct ring_item *out, *in, *right, *left;
} RING_ITEM, *ring;

ring ring_create(int n, int dim);
void ring_free(ring r);
void ring_excise(ring r);
void ring_free_interior(ring r);
void ring_extend(ring r);
void ring_dump(ring r);
void ring_plot(ring r, double *params, int color, int symbol);
void ring_save(ring r, memory m, double *params, int color, int symbol,
	       int ring_type, int skip);
ring ring_inner(ring r);

#endif
/* !RING_LOCAL_h */
