/*
 * $Id: dvector.c,v 1.2 1997/01/07 16:52:45 veran Exp $
 */

#include <stdlib.h>
#include <stdio.h>

#include <math_utils.h>
#include <utilities.h>

/*
 * dvector()
 *
 * memory allocation for a vector of doubles
 * returns m so that m[nl],...,m[nh] are the valid locations
 *
 * last modified:  8/21/91  paw
 */
double *
dvector(int nl, int nh)
{
  double *v;

  if (nh < nl) return(NULL);
  if ( (v = (double *) malloc((unsigned) (nh - nl + 1) * sizeof(double))) == NULL)
    {
      system_mess_proc(1,"dvector: allocation failure!");
    }
  else 
    {
      v -= nl;
    }
  return(v);
}


/*
 * free_dvector()
 *
 * frees memory allocated by dvector()
 *
 * last modified: 8/21/91  paw
 */
void
free_dvector(double *v, int nl, int nh)
{
  if (v == NULL) return;
  free((char *) (v + nl));
}
