/*
 * $Id: ivector.c,v 1.2 1997/01/07 16:52:45 veran Exp $
 */

#include <stdlib.h>
#include <stdio.h>

#include <math_utils.h>
#include <utilities.h>

/*
 * ivector()
 *
 * memory allocation for a vector of integers
 * returns m so that m[nl],...,m[nh] are the valid locations
 *
 * last modified:  8/21/91  paw
 */
int *
ivector(int nl, int nh)
{
  int *v;

  if (nh < nl) return(NULL);
  if ( (v = (int *) malloc((unsigned) (nh - nl + 1) * sizeof(int))) == NULL)
    {
      system_mess_proc(1,"ivector: allocation failure!");
    }
  else 
    {
      v -= nl;
    }
  return(v);
}


/*
 * free_ivector()
 *
 * frees memory allocated by ivector()
 *
 * last modified: 8/21/91  paw
 */
void
free_ivector(int *v, int nl, int nh)
{
  if (v == NULL) return;
  free((char *) (v + nl));
}
