/*
 * $Id: flow.c,v 1.2 1997/01/07 16:58:28 veran Exp $
 */

/*
 * flow.c
 *
 * Procedures:
 *   flow_forwards();
 *   flow_backwards();
 *   flow_continue();
 *   clear_last_trajectory();
 *   clear_all_trajs();
 *
 */
#include <stdio.h>
#include <pm.h>
#include <constants.h>
#include <memory.h>

#include "flow.h"

void
flow_forwards()
{
  pm(PUT, "Flow.Direction", FORWARD, NULL);
  traj_mem_orbit();
  pm(EXEC, "Memory.Count",
     EXEC, "Selected.Funct",
     NULL);
}

void
 flow_backwards()
{
  pm(PUT, "Flow.Direction", BACKWARD, NULL);
  traj_mem_orbit();
  pm(EXEC, "Memory.Count",
     EXEC, "Selected.Funct",
     NULL);
}

void
 flow_continue()
{
  traj_mem_orbit();
  pm(EXEC, "Memory.Count",
     EXEC, "Selected.Funct",
     NULL);
}


/*
 * routine to clear the last trajectory in the trajectory memory object
 */
void
clear_last_trajectory()
{
  memory m;

  m = (memory) pm(GET, "Memory.Traj", NULL);
  memory_delete_last_flow(m);
  pm(EXEC, "Memory.Count", NULL);
}


/*
 * clear_all_trajs()  clears the trajectory memory object
 *                     the viewing windows
 */
void
clear_all_trajs()
{
  pm(INIT, "Memory.Traj", TRAJ_MEMORY, 
     INIT, "Memory.Mult", MULT_MEMORY,
     EXEC, "Memory.Count",
     NULL);
}
