/*
 * $Id: pm_utils.c,v 1.2 1997/01/07 17:01:08 veran Exp $
 */

/*
 * pm_utils.c
 *
 * Procedures:
 *   pm_type()
 *
 */
#include <stdio.h>
#include <string.h>

#include <pm.h>
#include "pm_hash.h"
#include <constants.h>

/*
 * Execs one routine (if it exists) for each object in the postmaster
 * This routine name is specified by element.
 */
int
pm_exec_all(char *element)
{
  struct pm_list   *current;
  char *pc;
  int i, status = NO_ERROR;
  
  for( i=0; i<HASHSIZE; i++)
    {
      current = hashtab[i];
      while ( current != NULL )
	{    
	  if( (current->category == PM_ELEMENT) && (current->type == FNCT) )
	    {
	      if ( (pc = strchr(current->label,'.')) != (char *) NULL)
		{
		  pc++;
		  if ((strcmp(pc,element) == 0) &&
		      (current->data.fnct_ptr != NULL))
		    (current->data.fnct_ptr)();
		}
	    }
	  current = current->next_in_hash;
	}
    }
  return status;
}

/*
 * returns the type of a postmaster element, and how
 * many (if a list type).
 *
 */
int
pm_type(char *element, int *n, int *len)
{
  struct pm_list *element_ptr;

  element_ptr = pm_hash_lookup(element);
  if (element_ptr == NULL) return 0;
  
  if (n != NULL) *n = element_ptr->list_size;
  if (len != NULL) *len = element_ptr->string_max_len;
  return(element_ptr->type);
}


struct Key
{
  char      *word;
  int       index;
};

struct Key pm_type_key[] = {
  {"INT", INT},
  {"INT_LIST", INT_LIST},
  {"DBL", DBL},
  {"DBL_LIST", DBL_LIST},
  {"STRNG", STRNG},
  {"STRNG_LIST", STRNG_LIST},
  {"ADDRS", ADDRS},
  {"MEMRY", MEMRY},
  {"FNCT", FNCT},
  {"PM_OBJECT", PM_OBJECT},
  {"PM_ELEMENT", PM_ELEMENT},
  {"LIST_SIZE", LIST_SIZE},
  {"STRNG_LENGTH", STRNG_LENGTH}
};

int N_PMTYPES = sizeof(pm_type_key)/sizeof(struct Key);

struct  Key pm_key[] = {
  {"EXEC", EXEC},
  {"PUT", PUT},
  {"GET", GET},
  {"PUT_LIST", PUT_LIST},
  {"GET_LIST", GET_LIST},
  {"CLEAR", CLEAR},
  {"INIT", INIT},
  {"CREATE_OBJ", CREATE_OBJ},
  {"CREATE_ELEM", CREATE_ELEM},
  {"QUERY", QUERY}
};

int N_PMKEY = sizeof(pm_key)/sizeof(struct Key);


int
pm_typekeyword(char *word)
{
  int i;
  
  for (i=0; i< N_PMTYPES; i++)
    if (!strcmp(word,pm_type_key[i].word))
      return(pm_type_key[i].index);
  return(NO_KEY);
}


int
pm_keyword(char *word)
{
  int i;
  
  for (i=0; i< N_PMKEY; i++)
    if (!strcmp(word,pm_key[i].word))
      return(pm_key[i].index);
  return(NO_KEY);
}
