/*
 * $Id: interrupt.c,v 1.2 1997/01/07 17:04:08 veran Exp $
 */

/*
 * interrupt.c
 *
 * Routines for the interrupt signal control.
 *
 */
#include <sys/time.h>
#include <sys/times.h>

#include <constants.h>
#include <utilities.h>

static int stop_flag;
struct timeval lasttime = {0,0};
struct timezone tz = {0, 0};

int
interrupt()
{
  struct timeval thistime;
  long dt = 1000000;  /* 10^6 microseconds = 1 sec */

  /* find out how much time has passed since lasttime the screen was updated */
  if (gettimeofday(&thistime,&tz) == 0)
    {
      dt = dt * (thistime.tv_sec - lasttime.tv_sec) +
	(thistime.tv_usec - lasttime.tv_usec);
    }
  
  if (dt > 100000)
    {
      /* more than 0.1 secs have passed so update the screen
	 allowing Ctrl-C to be accepted */
      tcl_update();
      lasttime.tv_sec = thistime.tv_sec;
      lasttime.tv_usec = thistime.tv_usec;
    }

  return stop_flag;
}


void
  set_interrupt()
{
  stop_flag = TRUE;
}


void
  reset_interrupt()
{
  stop_flag = FALSE;
}
