/*
 * $Id: view.c,v 1.2 1997/01/07 17:05:10 veran Exp $
 */

/*
 * view.c
 *
 */

#include <stdio.h>
#include <stdlib.h>

#include <view.h>


VIEW_ITEM *Views = NULL;

VIEW_ITEM *
add_view(int type, int number)
{
  VIEW_ITEM **cv, *v;

  /* look to see if this view exists already! */
  cv = &Views;
  while (*cv) {
    if (((*cv)->type == type) && ((*cv)->number == number)) {
      fprintf(stdout, "Warning: this view already exists!\n");
      return (*cv);
    }
    cv = &((*cv)->next_View);
  }

  /* create new view */
  v = (VIEW_ITEM *) calloc(1, sizeof(VIEW_ITEM));
  v->type = type;
  v->number = number;
  v->next_View = NULL;
  (*cv) = v;

  return v;
}

void
dismiss_view(int type, int number) 
{
  VIEW_ITEM **cv, *old;

  /* look to see if this view exists already! */
  cv = &Views;
  while (*cv) {
    if (((*cv)->type == type) && ((*cv)->number == number)) {
      old = *cv;
      (*cv) = (*cv)->next_View;
      free((char *) old);
      dump_views();
      return;
    }
    cv = &((*cv)->next_View);
  }
  
  fprintf(stdout, "Warning: this view does not exist, so can not dismiiss.\n");
  dump_views();
  return;
}

VIEW_ITEM *
get_view(int type, int number)
{
  VIEW_ITEM *cv = Views;
  while (cv) {
    if ( (cv->type == type) && (cv->number == number) )
      return cv;
    cv = cv->next_View;
  }
  return (VIEW_ITEM *) NULL;
}

void
dump_views()
{
  VIEW_ITEM *v = Views;

  fprintf(stdout, "Current views are: \n");
  while (v) {
    switch (v->type)
      {
      case TWOD:
	twod_dump(v);
	break;
      case ONED:
      case GEOMVIEW:
      default:
	fprintf(stdout, "  %s %d\n", win_keyindex(v->type), v->number);
	break;
      }
    v = v->next_View;
  }
}

/*
 * plots a memory object on all views
 */
void
view_plot_mem(memory m)
{
  VIEW_ITEM *v = Views;

  while (v) {
    switch (v->type)
      {
      case TWOD:
	twod_mem(v,m);
	break;
      case ONED:
      case GEOMVIEW:
      default:
	fprintf(stdout, "view_plot_mem: unrecognized view object.\n");
	break;
      }
    v = v->next_View;
  }
}
